BBBatScale/core/urls.py
from core.views import (
    api,
    create_join,
    groups,
    home_room,
    import_export,
    personal_room,
    recordings,
    room_configurations,
    rooms,
    servers,
    settings,
    statistics,
    tenants,
    users,
)
from django.urls import path

urlpatterns = [
    path("api/callback/bbb/", api.callback_bbb, name="callback_bbb"),
    path("api/recording/postporocessing/done/", api.recording_callback),
    path("api/servers/registration", api.api_server_registration, name="api_server_registration"),
    path("servers/overview", servers.servers_overview, name="servers_overview"),
    path("rooms/overview", rooms.rooms_overview, name="rooms_overview"),
    path("tenants/overview", tenants.tenant_overview, name="tenants_overview"),
    path("rooms/configs/overview", room_configurations.room_config_overview, name="room_configs_overview"),
    path("server/create/", servers.server_create, name="server_create"),
    path("server/delete/<int:server>", servers.server_delete, name="server_delete"),
    path("server/update/<int:server>", servers.server_update, name="server_update"),
    path("room/create/", rooms.room_create, name="room_create"),
    path("room/delete/<int:room>", rooms.room_delete, name="room_delete"),
    path("room/update/<int:room>", rooms.room_update, name="room_update"),
    path("home_room/update<int:home_room>", home_room.home_room_update, name="home_room_update"),
    path("personal_room/create", personal_room.personal_room_create, name="personal_room_create"),
    path("personal_room/update/<int:personal_room>", personal_room.personal_room_update, name="personal_room_update"),
    path("personal_room/delete/<int:personal_room>", personal_room.personal_room_delete, name="personal_room_delete"),
    path("statistics", statistics.statistics, name="statistics"),
    path("importexport", import_export.import_export, name="import_export"),
    path("export/json", import_export.export_download_json, name="export_download_json"),
    path("export/csv", import_export.export_download_csv, name="export_download_csv"),
    path("import/json", import_export.import_upload_json, name="import_upload_json"),
    path("import/csv", import_export.import_upload_csv, name="import_upload_csv"),
    path("room/config/create/", room_configurations.room_config_create, name="room_config_create"),
    path("room/config/delete/<int:room_config>", room_configurations.room_config_delete, name="room_config_delete"),
    path("room/config/update/<int:room_config>", room_configurations.room_config_update, name="room_config_update"),
    path("tenant/create/", tenants.tenant_create, name="tenant_create"),
    path("tenant/delete/<int:tenant>", tenants.tenant_delete, name="tenant_delete"),
    path("tenant/update/<int:tenant>", tenants.tenant_update, name="tenant_update"),
    path("recordings/overview/", recordings.recordings_list, name="recordings_list"),
    path("users/overview/", users.users_overview, name="users_overview"),
    path("user/create/", users.user_create, name="user_create"),
    path("user/change/password/", users.user_change_password, name="change_password"),
    path("user/change/theme/", users.user_change_theme, name="change_theme"),
    path("user/delete/<int:user>", users.user_delete, name="user_delete"),
    path("user/update/<int:user>", users.user_update, name="user_update"),
    path("user/change/password/admin/<int:user>", users.user_change_password_admin, name="user_reset_password_admin"),
    path("groups/overview/", groups.groups_overview, name="groups_overview"),
    path("group/create/", groups.group_create, name="group_create"),
    path("group/delete/<int:group>", groups.group_delete, name="group_delete"),
    path("group/update/<int:group>", groups.group_update, name="group_update"),
    path("join/create/meeting/<str:meeting_id>", create_join.join_or_create_meeting, name="join_or_create_meeting"),
    path("create/meeting/<str:meeting_id>", create_join.create_meeting, name="create_meeting"),
    path("set/username/join/<str:meeting_id>", create_join.session_set_username_pre_join, name="set_username_pre_join"),
    path("join/meeting/<str:meeting_id>", create_join.join_meeting, name="join_meeting"),
    path("join/meeting/anon/", create_join.session_set_username, name="session_set_username"),
    path("meeting/status/<str:meeting_id>", create_join.get_meeting_status, name="get_meeting_status"),
    path("room/meeting/end/<int:room_pk>", rooms.force_end_meeting, name="force_end_meeting"),
    path("<str:tenant_name>/bigbluebutton/api/", api.bbb_initialization_request),
    path("<str:tenant_name>/bigbluebutton/api/join", api.bbb_api_join),
    path("<str:tenant_name>/bigbluebutton/api/create", api.bbb_api_create),
    path("<str:tenant_name>/bigbluebutton/api/getMeetingInfo", api.bbb_api_get_meeting_info),
    path("<str:tenant_name>/bigbluebutton/api/end", api.bbb_api_end),
    path("<str:tenant_name>/bigbluebutton/api/getRecordings", api.bbb_api_get_recordings),
    path("settings", settings.settings_edit, name="settings_edit"),
    path("coowner/user/search", users.user_search_json, name="json_search_user"),
]

BBBatScale/core/models.py
from __future__ import annotations

import logging
import random
import uuid
from collections import defaultdict
from datetime import timedelta
from hashlib import sha1
from math import ceil
from typing import Optional

from core.constants import (
    GUEST_POLICY,
    GUEST_POLICY_ALLOW,
    ROOM_STATE,
    ROOM_STATE_ACTIVE,
    ROOM_STATE_INACTIVE,
    SCHEDULING_STRATEGIES,
    SCHEDULING_STRATEGY_LEAST_PARTICIPANTS,
    SCHEDULING_STRATEGY_LEAST_UTILIZATION,
    SCHEDULING_STRATEGY_RANDOM_PICK_FROM_LEAST_UTILIZED,
    SERVER_STATE_DISABLED,
    SERVER_STATE_ERROR,
    SERVER_STATE_UP,
    SERVER_STATE_WAITING_RESPONSE,
    SERVER_STATES,
    WEBHOOKS,
)
from core.utils import BigBlueButton
from django.conf import settings
from django.contrib.auth.models import AbstractUser
from django.core import validators
from django.core.validators import MinValueValidator
from django.db import IntegrityError, models, transaction
from django.db.models import Sum
from django.db.models.signals import m2m_changed
from django.db.transaction import atomic
from django.templatetags.static import static
from django.utils.crypto import get_random_string
from django.utils.deconstruct import deconstructible
from django.utils.timezone import now
from django.utils.translation import gettext
from django.utils.translation import gettext_lazy as _

logger = logging.getLogger(__name__)


def get_default_room_config() -> RoomConfiguration:
    return RoomConfiguration.objects.get_or_create(name="Default")[0]


def get_default_room_config_id() -> int:
    return get_default_room_config().id


def _random_token() -> str:
    return get_random_string(length=10)


def _random_meeting_id() -> str:
    return uuid.uuid4().hex


@deconstructible
class UnicodeUsernameValidator(validators.RegexValidator):
    regex = r"^[\w.@+-=]+\Z"
    message = _("Enter a valid username. This value may contain only letters, " "numbers, and @/./+/-/_/= characters.")
    flags = 0


class User(AbstractUser):
    username_validator = UnicodeUsernameValidator()

    username = models.CharField(
        _("username"),
        max_length=255,
        unique=True,
        help_text=_("Required. 255 characters or fewer. Letters, digits and @/./+/-/_/= only."),
        validators=[username_validator],
        error_messages={
            "unique": _("A user with that username already exists."),
        },
    )
    theme = models.ForeignKey("Theme", on_delete=models.SET_NULL, null=True)
    personal_rooms_max_number = models.IntegerField(null=True, blank=True)
    display_name = models.CharField(max_length=255, blank=True, null=True)

    def __str__(self) -> str:
        if self.display_name:
            return self.display_name
        elif self.first_name and self.last_name:
            return f"{self.last_name}, {self.first_name}"
        elif self.first_name:
            return self.first_name
        elif self.last_name:
            return self.last_name
        elif self.email:
            return self.email
        return gettext("Unknown")

    def get_max_number_of_personal_rooms(self):
        if self.personal_rooms_max_number is not None:
            return self.personal_rooms_max_number
        else:
            general_parameters: GeneralParameter = GeneralParameter.load()
            if self.groups.filter(name=settings.MODERATORS_GROUP).exists():
                return general_parameters.personal_rooms_teacher_max_number
            else:
                return general_parameters.personal_rooms_non_teacher_max_number

    def get_theme(self) -> Theme:
        theme = self.theme
        if theme is None:
            theme = GeneralParameter.load().default_theme
        return theme

    @property
    def homeroom(self) -> Optional[HomeRoom]:
        with atomic():
            general_parameter = GeneralParameter.load()

            if general_parameter.home_room_enabled and (
                not general_parameter.home_room_teachers_only
                or self.is_superuser
                or self.groups.filter(name=settings.MODERATORS_GROUP).exists()
            ):
                try:
                    return self.homeroom_ptr
                except User.homeroom_ptr.RelatedObjectDoesNotExist:
                    if (
                        general_parameter.home_room_tenant is None
                        or general_parameter.home_room_room_configuration is None
                    ):
                        return None

                    logger.debug("Create homeroom for user %s", self.username)
                    try:
                        if self.email and not HomeRoom.objects.filter(name=f"home-{self.email}").exists():
                            room_name = f"home-{self.email}"
                        else:
                            room_name = f"home-{self.last_name}-{sha1(bytes(self.username, 'UTF-8')).hexdigest()[:8]}"

                        homeroom = HomeRoom.objects.create(
                            name=room_name,
                            owner=self,
                            tenant=general_parameter.home_room_tenant,
                            is_public=False,
                            config=general_parameter.home_room_room_configuration,
                        )
                        logger.debug(
                            "Home room created with the following parameters: "
                            + "name=%s owner=%s tenant=%s is_public=%s config=%s",
                            room_name,
                            self.username,
                            general_parameter.home_room_tenant,
                            False,
                            general_parameter.home_room_room_configuration,
                        )
                        return homeroom
                    except IntegrityError as e:
                        logger.warning("Home room could not be created. " + str(e))

        return None


class Tenant(models.Model):
    name = models.CharField(max_length=255, unique=True)
    description = models.CharField(max_length=255, null=True, blank=True)
    notifications_emails = models.TextField(null=True, blank=True)
    token_registration = models.CharField(max_length=255, default=_random_token)
    scheduling_strategy = models.CharField(
        max_length=255, choices=SCHEDULING_STRATEGIES, default=SCHEDULING_STRATEGY_LEAST_UTILIZATION
    )

    def __str__(self):
        return self.name

    def get_current_participant_count(self):
        return self.room_set.all().aggregate(Sum("participant_count"))["participant_count__sum"] or 0

    def get_utilization(self):
        usage = 0
        for server in self.get_servers_up():
            usage = usage + server.get_utilization()
        return ceil(usage)

    def get_utilization_max(self):
        return ceil(sum(map(lambda server: server.videostream_count_max, self.get_servers_up())))

    def get_utilization_percent(self):
        utilization_max = self.get_utilization_max()
        return 0 if utilization_max <= 0 else int(round(self.get_utilization() / utilization_max, 2) * 100)

    def get_server_for_room(self):  # noqa C901 # TODO needs to be refactored due to very high complexity
        server_to_be = None
        worker = ServerType.objects.get(name="worker")
        logger.info("Selecting new server for scheduling with strategy: {}".format(self.scheduling_strategy))

        if self.scheduling_strategy == SCHEDULING_STRATEGY_LEAST_PARTICIPANTS:
            min_count = 1000
            for server in self.server_set.filter(state=SERVER_STATE_UP, server_types__in=[worker]):
                pc = server.get_participant_count()
                if pc < min_count:
                    min_count = pc
                    server_to_be = server
                    logger.info("Best candidate so far: {}".format(server_to_be))

        if self.scheduling_strategy == SCHEDULING_STRATEGY_LEAST_UTILIZATION:
            min_count = 1000
            for server in self.server_set.filter(state=SERVER_STATE_UP, server_types__in=[worker]):
                pc = server.get_utilization()
                if pc < min_count:
                    min_count = pc
                    server_to_be = server
                    logger.info("Best candidate so far: {}".format(server_to_be))

        if self.scheduling_strategy == SCHEDULING_STRATEGY_RANDOM_PICK_FROM_LEAST_UTILIZED:

            def get_server_utilization_list():
                servers_utilization = []
                for server in self.server_set.filter(state=SERVER_STATE_UP, server_types__in=[worker]):
                    servers_utilization.append([server.get_utilization(), server])

                servers_utilization_sorted = sorted(servers_utilization, key=lambda x: x[0])

                return servers_utilization_sorted

            def get_servers_with_zero_utilization(server_utilization_list):
                zero_utilization_servers = []
                for utilization, server in server_utilization_list:
                    if utilization == 0:
                        zero_utilization_servers.append(server)

                return zero_utilization_servers

            def get_server_with_least_utilization(server_utilization_list, min_number_of_least_utilized_servers):
                utilizations_with_servers = defaultdict(list)
                for utilization, server in server_utilization_list:
                    utilizations_with_servers[utilization].append(server)

                sorted_utilizations_server_share = sorted(utilizations_with_servers.keys())

                selected_servers = []

                for utilization in sorted_utilizations_server_share:
                    selected_servers += utilizations_with_servers[utilization]

                    if len(selected_servers) >= min_number_of_least_utilized_servers:
                        break

                return selected_servers

            def randomy_pick_server_from_list(candidates):

BBBatScale/core/views/groups.py
from core.filters import GroupFilter
from core.forms import GroupFilterFormHelper, GroupForm
from django.contrib import messages
from django.contrib.admin.views.decorators import staff_member_required
from django.contrib.auth.decorators import login_required
from django.contrib.auth.models import Group
from django.http import HttpResponseRedirect
from django.shortcuts import get_object_or_404, redirect, render
from django.utils.translation import gettext_lazy as _


@login_required
@staff_member_required
def groups_overview(request):
    f = GroupFilter(request.GET, queryset=Group.objects.all())
    f.form.helper = GroupFilterFormHelper
    return render(request, "groups_overview.html", {"filter": f})


@login_required
@staff_member_required
def group_create(request):
    form = GroupForm(request.POST or None)
    if request.method == "POST" and form.is_valid():
        group = form.save(commit=False)
        # Custom form validations

        group.save()
        messages.success(request, _("Group {} successfully created.").format(group.name))
        # return to URL
        return redirect("groups_overview")
    return render(request, "group_create.html", {"form": form})


@login_required
@staff_member_required
def group_delete(request, group):
    instance = get_object_or_404(Group, pk=group)
    instance.delete()
    messages.success(request, _("Group successfully deleted."))
    return HttpResponseRedirect(request.META.get("HTTP_REFERER", "/"))


@login_required
@staff_member_required
def group_update(request, group):
    instance = get_object_or_404(Group, pk=group)

    if request.method == "POST":
        form = GroupForm(request.POST, instance=instance)
        if form.is_valid():
            _group = form.save(commit=False)

            _group.save()

            messages.success(request, _("Group {} successfully updated").format(_group.name))
            return redirect("groups_overview")
    form = GroupForm(instance=instance, initial={"name": instance.name})
    return render(request, "group_create.html", {"form": form})

BBBatScale/core/views/statistics.py
import logging

from core.models import Meeting, Room, Server, Tenant
from core.views import create_view_access_logging_message
from django.shortcuts import render

logger = logging.getLogger(__name__)


def statistics(request):
    logger.info(create_view_access_logging_message(request))

    return render(
        request,
        "statistics.html",
        {
            "servers": Server.objects.all(),
            "rooms": Room.objects.all(),
            "participants_current": Room.get_participants_current(),
            "performed_meetings": Meeting.objects.all().count(),
            "tenants": Tenant.objects.all(),
        },
    )

BBBatScale/core/templates/change_theme.html
{% extends "base.html" %}
{% load i18n %}
{% load theme %}

{% block content %}
    <div class="row">
        <div class="col-md-6 offset-md-3">
            <div class="card card-info">
                <div class="card-header">
                    <span class="card-title">{% translate "Change Theme" %}</span>
                </div>
                <div class="card-body">
                    <form id="change-theme" method="POST" action="{% url "change_theme" %}">
                        {% csrf_token %}
                        {% for theme in themes %}
                            <div class="form-group">
                                <div class="form-check">
                                    <label class="form-check-label">
                                        <input class="form-check-input" type="radio" name="theme" value="{{ theme.pk }}"
                                               {% if request.user.get_theme == theme %}checked{% endif %}>
                                        {{ theme.name }}
                                    </label>
                                </div>
                            </div>
                        {% endfor %}
                    </form>
                </div>
                <div class="card-footer">
                    <div class="row">
                        <div class="col-8">
                        </div>
                        <div class="col-4">
                            <button class="btn btn-primary btn-block" form="change-theme" type="submit">
                                {% translate "Change" %}
                            </button>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
{% endblock %}

BBBatScale/core/templates/configure_room_for_meeting.html
{% extends "base.html" %}
{% load crispy_forms_tags %}
{% load i18n %}

{% block styles %}
    <style>
        .separator {
            width: 100%;
            text-align: center;
            overflow: hidden;
            display: flex;
            align-items: center;
        }

        .separator .separator-line {
            height: 0.05em;
            content: "";
            flex-grow: 1;
        }

        .separator .separator-label {
            margin: 0 1em;
        }
    </style>
{% endblock %}

{% block content %}
    <section class="content">
        <div class="container-fluid">
            <div class="row">
                <div class="col-12">
                    <div class="card">
                        <div class="card-header">
                            <h3 class="card-title">{% trans "Start a room" %}</h3>
                        </div>

                        <div class="card-body">
                            <div class="p-3">
                                <p>
                                    {% blocktranslate trimmed %}
                                        If you do not want to create the meeting and wait for another moderator to start
                                        this room, you can join the waiting room.
                                    {% endblocktranslate %}
                                </p>
                                <a class="btn btn-secondary"
                                   href="{% url "join_meeting" room.meeting_id %}">{% translate "Join waiting room" %}</a>
                            </div>
                            <div class="separator my-4">
                                <div class="separator-line bg-secondary"></div>
                                <span class="separator-label">{% translate "Or" %}</span>
                                <div class="separator-line bg-secondary"></div>
                            </div>
                            <div class="p-3">
                                <p>
                                    {% blocktranslate trimmed with room_config=room.config %}
                                        Start the room <strong>{{ room }}</strong> with the configuration
                                        <strong>{{ room_config }}</strong> and the following parameters. The settings
                                        can be adjusted as needed for this meeting.
                                    {% endblocktranslate %}
                                </p>
                                {% crispy form %}
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </section>
{% endblock %}

BBBatScale/core/templates/group_create.html
{% extends "base.html" %}
{% load static %}
{% load crispy_forms_tags %}
{% load i18n %}
{% load theme %}

{% block styles %}
    {% theme "multi_select" "stylesheet" %}
{% endblock %}

{% block content %}
    <section class="content">
        <div class="container-fluid">
            <div class="row">
                <div class="col-12">
                    <div class="card">
                        <div class="card-header">
                            <h3 class="card-title">{% trans "Group form" %}</h3>
                        </div>
                        <!-- /.card-header -->
                        <div class="card-body">
                            {% crispy form %}

                        </div>

                        <!-- /.card-body -->
                    </div>
                </div>
            </div>
        </div>
    </section>
{% endblock %}

BBBatScale/core/templates/password_change.html
{% extends "base.html" %}
{% load static %}
{% load crispy_forms_tags %}
{% load i18n %}

{% block content %}
    <section class="content">
        <div class="container-fluid">
            <div class="row">
                <div class="col-12">
                    <div class="card">
                        <div class="card-header">
                            <h3 class="card-title">{% trans "Password change form" %}</h3>
                        </div>
                        <!-- /.card-header -->
                        <div class="card-body">
                            {% crispy form %}
                        </div>
                        <!-- /.card-body -->
                    </div>
                </div>
            </div>
        </div>
    </section>
{% endblock %}

BBBatScale/core/templates/room_configs_create.html
{% extends "base.html" %}
{% load crispy_forms_tags %}
{% load i18n %}

{% block content %}
    <section class="content">
        <div class="container-fluid">
            <div class="row">
                <div class="col-12">
                    <div class="card">
                        <div class="card-header">
                            <h3 class="card-title">{% trans "Configure room type" %}</h3>
                        </div>
                        <!-- /.card-header -->
                        <div class="card-body">
                            {% crispy form %}
                        </div>
                        <!-- /.card-body -->
                    </div>
                </div>
            </div>
        </div>
    </section>
{% endblock %}

BBBatScale/core/templates/tenants_create.html
{% extends "base.html" %}
{% load crispy_forms_tags %}
{% load i18n %}

{% block content %}
    <section class="content">
        <div class="container-fluid">
            <div class="row">
                <div class="col-12">
                    <div class="card">
                        <div class="card-header">
                            <h3 class="card-title">{% trans "Tenant form" %}</h3>
                        </div>
                        <!-- /.card-header -->
                        <div class="card-body">
                            {% crispy form %}
                        </div>
                        <!-- /.card-body -->
                    </div>
                </div>
            </div>
        </div>
    </section>
{% endblock %}

BBBatScale/core/templates/tenants_overview.html
{% extends "base.html" %}
{% load static %}
{% load i18n %}
{% load crispy_forms_tags %}

{% block scripts %}
    <script>
        function deleteTenant(url) {
            jQuery('#delete_tenant').attr('href', url);
            jQuery('#delete_tenant_modal').modal('toggle');
        }
    </script>
{% endblock %}

{% block content %}
    <section class="content">
        <div class="container-fluid">
            <div class="row mb-1">
                <div class="col-12 card">
                    <div class="card-body">
                        {% crispy filter.form filter.form.helper %}
                    </div>
                </div>
            </div>
            <div class="row">
                <div class="col-12">
                    <div class="card">
                        <div class="card-header">
                            <h3 class="card-title" id="table_desc">{% trans "Tenants overview" %}<span
                                    class="badge badge-pill badge-primary ml-1">{{ filter.qs.count }}</span></h3>
                            <div class="card-tools">
                                <a class="btn btn-sm btn-default float-right" href="{% url 'tenant_create' %}"><em
                                        class="fas fa-plus"></em></a>
                            </div>
                        </div>
                        <!-- /.card-header -->
                        <div class="card-body table-responsive p-0">
                            <table aria-describedby="table_desc" class="table table-hover table-sm">
                                <thead class="thead-light">
                                <tr>
                                    <th scope="col">{% trans "Name" %}</th>
                                    <th scope="col">{% trans "Scheduling Strategy" %}</th>
                                    <th scope="col">{% trans "Description" %}</th>
                                    <th scope="col">{% trans "Email Notifications" %}</th>
                                    <th scope="col" class="text-right">{% trans "Action" %}</th>
                                </tr>
                                </thead>
                                <tbody>
                                <!-- empty table row to fix data table tooltip bug with only one entry -->
                                <tr>
                                    <td></td>
                                    <td></td>
                                    <td></td>
                                    <td></td>
                                    <td></td>
                                </tr>
                                {% for tenant in filter.qs %}
                                    <tr>
                                        <td>{{ tenant.name }}</td>
                                        <td>{{ tenant.get_scheduling_strategy_display }}</td>
                                        <td>{{ tenant.description|default_if_none:"" }}</td>
                                        <td>{{ tenant.notifications_emails }}</td>
                                        <td>
                                            <div class="btn-group btn-group-sm float-right">
                                                <a class="btn btn-success"
                                                   href="{% url 'tenant_update' tenant.pk %}"
                                                   data-toggle="tooltip" data-placement="top"
                                                   title="{% trans "Edit" %}">
                                                    <em class="fas fa-pen"></em>
                                                </a>
                                                <button class="btn btn-danger"
                                                        onclick="deleteTenant('{% url "tenant_delete" tenant.pk %}')"
                                                        data-toggle="tooltip" data-placement="top"
                                                        title="{% trans "Delete" %}">
                                                    <em class="fas fa-trash-alt"></em>
                                                </button>
                                            </div>
                                        </td>
                                    </tr>
                                {% endfor %}
                                </tbody>
                            </table>
                        </div>
                        <!-- /.card-body -->
                    </div>
                </div>
            </div>
        </div>
    </section>

    <div id="delete_tenant_modal" class="modal fade" tabindex="-1" role="dialog"
         aria-labelledby="CenterModalLabel"
         aria-hidden="true" style="display: none;">
        <div class="modal-dialog modal-dialog-centered">
            <div class="modal-content">
                <div class="modal-header">
                    <h4 class="modal-title" id="CenterModalLabel">{% trans "Delete tenant" %}</h4>
                    <button type="button" class="close" data-dismiss="modal" aria-hidden="true">×</button>
                </div>
                <div class="modal-body">
                    {% trans "Are you sure you want to delete the tenant?" %}
                </div>
                <div class="modal-footer">
                    <a class="btn btn-danger" href=""
                       data-toggle="tooltip" data-placement="top" title="Löschen" id="delete_tenant">
                        {% trans "Delete" %}
                    </a>
                    <button type="button" class="btn btn-secondary waves-effect"
                            data-dismiss="modal">{% trans "Cancel" %}</button>
                </div>
            </div><!-- /.modal-content -->
        </div><!-- /.modal-dialog -->
    </div>
{% endblock %}